/* 
 * ִ   ǻ к  ȸ '(http://hantor.ajou.ac.kr)'
 * 2002  7  ȸ ǰ.
 * : ̽¿.
 * α׷    liv@livnow.net  ֽðų  ȸ
 * Ȩ Խǿ ֽʽÿ.
 */

#ifndef DATA_STRUCTURE
#define DATA_STRUCTURE

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define MASTER 0

typedef struct _node {
	void *data;

	struct _node *next;
} node;

int init();
int add(int handler_id,void *data,int data_len);
void* get(void *t,int handler_id,int pos);
int del(int handler_id,int pos);
int size();
int add_handler(node *head);
node* get_handler(int handler_id);

node *master_head=NULL;
int handler_num=0;

/* init()
 * ȯ:	 DBڵ, н -1
 * :	ڷᱸ ʱȭѴ. ڷᱸ ϱ   ȣ Ѵ.
 */
int init() {
	node *head;
	int handler_id;

	if(handler_num==0) {
		master_head=(node*)malloc(sizeof(node));
		if(master_head==NULL) {
			return -1;
		}
		master_head->next=(node*)malloc(sizeof(node));
		master_head->next->next=master_head;
		master_head->next->data=(node*)malloc(sizeof(node*));
		memcpy(master_head->next->data,&master_head,sizeof(node*));
	}

	head=(node*)malloc(sizeof(node));
	if(head==NULL) {
		return -1;
	}

	head->next=head;

	handler_id=add_handler(head);
	if(handler_id==-1) {
		return -1;
	}

	return handler_id;
}

/* add_handler()
 * ȯ:	DBڵ
 * :	ο ũ Ʈ  Ʈ ϰ
 * 			߿  ũ Ʈ ã  ִ DBڵ ش.
 */
int add_handler(node *head) {
	add(MASTER,&head,sizeof(node*));
	handler_num++;

	return handler_num;
}


/* get_handler(DBڵ)
 * ȯ:	 ũ Ʈ HEAD, н NULL
 * :	 Ͻѵ״ ũ Ʈ ͸Ʈ ãƼ
 * 			 HEAD ּҸ ȯѴ.
 */
node* get_handler(int handler_id) {
	int i;
	node *t;

	if(handler_id<0) {
		return NULL;
	}

	t=master_head;
	for(i=0;i<=handler_id;i++) {
		t=t->next;
	}

	memcpy(&t,t->data,sizeof(node*));

	return t;
}

/* add(DBڵ, ڷ, ڷ )
 * ȯ:	 0, н -1
 * :	ڷḦ ش ڵ ũ帮Ʈ  ߰Ѵ.
 * 			ڷ    ޸ 󿡼 ϴ ũ⸦ Ȯ Ѱ־ Ѵ.
 */
int add(int handler_id,void *data,int data_len) {
	node *head,*last,*t;

	if(handler_id<0) {
		return -1;
	}

	head=get_handler(handler_id);
	if(head==NULL) {
		return -1;
	}

	t=(node*)malloc(sizeof(node));
	if(t==NULL) {
		return -1;
	}

	t->data=(node*)malloc(data_len);
	if(t->data==NULL) {
		return -1;
	}

	memcpy(t->data,data,data_len);

	last=head;
	while((last->next)!=head) {
		last=last->next;
	}

	t->next=last->next;
	last->next=t;

	return 0;
}

/* get(ڷᰡ  ּ, DBڵ, ġ)
 * ȯ:	 ڷ ּ, н NULL
 * :	ũ帮Ʈ ش ġ ڷḦ ȯش.
 * 			̰ ũ Ʈ ޸𸮻 ּ(۷) Ѱִ 
 * 			 纻 Ѱִ  ƴϹǷ װ  ϴ   ʴ.
 */
void* get(void *data,int handler_id,int pos) {
	node *head,*t;
	int i;

	if(handler_id<0) {
		return NULL;
	}

	if(pos<0 || pos>size(handler_id)) {
		data=NULL;
		return NULL;
	}

	head=get_handler(handler_id);
	t=head->next;

	for(i=0;i<pos;i++) {
		t=t->next;
	}

	data=t->data;

	return data;
}

/* del(DBڵ, ġ)
 * ȯ:	 0, н -1
 * :	ũ帮Ʈ ش ġ ڷḦ Ѵ.
 */
int del(int handler_id,int pos) {
	node *head,*prev_t,*t;
	int i;

	if(handler_id<0) {
		return -1;
	}

	head=get_handler(handler_id);
	if(head==NULL) {
		return -1;
	}

	prev_t=head;
	t=prev_t->next;

	for(i=0;i<pos;i++) {
		prev_t=t;
		t=t->next;		// go to next node
	}

	prev_t->next=t->next;
	free(t->data);
	free(t);

	return 0;
}

/* size(DBڵ)
 * ȯ:	 ũ帮Ʈ , н -1
 * :	ش ũ帮Ʈ ̸ ȯѴ.
 */
int size(int handler_id) {
	node *head,*t;
	int size=0;

	if(handler_id<0) {
		return -1;
	}

	head=get_handler(handler_id);

	t=head;
	while(1) {
		t=t->next;
		if(t==head) {
			break;
		}
		size++;
	}

	return size;
}

#endif
