/* 
 * ִ   ǻ к  ȸ '(http://hantor.ajou.ac.kr)'
 * 2002  7  ȸ ǰ.
 * : ̽¿.
 * α׷    liv@livnow.net  ֽðų  ȸ
 * Ȩ Խǿ ֽʽÿ.
 */

/*
 *	D			[0-9]								// 
 *	L			[a-zA-Z_]							// ĺ
 *	H			[a-fA-F0-9]							// 16 
 *	E			[Ee][+-]?{D}+						// 10  
 *	FS			(f|F|l|L)							// Ǽ  ڿ ٴ  ǥ ȣ(1L=long 1)
 *	IS			(u|U|l|L)*							//   ڿ ٴ  ǥ ȣ(1u=unsigned 1)
 *	HAN			([\xb0-\xc8\xa4_][\xa1-\xfe_])+		// ѱ(ϼ)
 */
D			[0-9]
L			[a-zA-Z_]
H			[a-fA-F0-9]
E			[Ee][+-]?{D}+
FS			(f|F|l|L)
IS			(u|U|l|L)*
HAN			([\xb0-\xc8\xa4][\xa1-\xfe])

%{
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <errno.h>
#include <mcheck.h>

#include "convtbl_db.h"
#include "includetbl_db.h"
#include "yybuf_stack.h"
#include "get_alphabetic_hangul.h"

#define IDENTIFIER_MAX_LENGTH 63							// ̸(, Լ, ..) ִ 

#ifndef ORIG_CPP
	#error "Add the following at gcc option"
	#error "ORIG_CPP=`find /usr/lib/gcc-lib/ -name 'cpp1'`"
	#error "-D\"$(ORIG_CPP)\""
#endif

struct {
	char hanc_path[1024];
	char gcc_path[1024];
	int debug;
} config;

int yywrap();
void count();
char* get_english_name(char *hangul_name);
int include_header_file();
void bypass_comment();
int load_config_file(char *config_path);
int load_converting_table(char *filename);

char english_name[IDENTIFIER_MAX_LENGTH+1];	// ̸ ص 
convtbl_node *convtbl_temp;					// ȯ ̺ ˻  ص  ִ ȯ ̺ ۾ ӽ 
%}

%%
"/*"																{ bypass_comment(); }
"//".*$																{ fputs(yytext,yyout); }
"#"[ ]+																{ unput('#'); }

"#hinclude"															{ 
																		//   о鿩 ѿ ȯ Ѵ.
																		include_header_file();
																	}
"#include"															{
																		/* 
																			preprocessor μ  
																			 Ƿ #include 
																			ó ʴ´.
																		*/
																		fputs(yytext,yyout);
																	}
"#progma"|"##"|"\\"|"#else"|"#error"|"#endif"|"#define"|"#ifdef"	{ fputs(yytext,yyout); }
"#error"|"#if"|"#elif"|"#line"|"#progma"|"#undef"|"#ifndef"			{ fputs(yytext,yyout); }
#{HAN}({HAN}|{L}|{D})+												{
																		char *english_name;

																		english_name=get_english_name(yytext);
																		if(strcmp(english_name,"#hinclude")==0) {
																			include_header_file();
																		} else {
																			fputs(english_name,yyout);
																		}
																	}

"auto"|"break"|"case"|"char"|"const"|"continue"|"default"|"do"				{ fputs(yytext,yyout); }
"double"|"else"|"enum"|"extern"|"float"|"for"|"goto"|"if"|"int"				{ fputs(yytext,yyout); }
"long"|"register"|"return"|"short"|"signed"|"sizeof"|"static"				{ fputs(yytext,yyout); }
"struct"|"switch"|"typedef"|"union"|"unsigned"|"void"|"volatile"|"while"	{ fputs(yytext,yyout); }

{HAN}({HAN}|{L}|{D})+														{
																				// Ϲ ѱ ̸(, Լ)
																				fputs(get_english_name(yytext),yyout);
																			}
{L}({L}|{D})*																{ fputs(yytext,yyout); }
                                                                        
0[xX]{H}+{IS}?																{ fputs(yytext,yyout); }
0{D}+{IS}?																	{ fputs(yytext,yyout); }
{D}+{IS}?																	{ fputs(yytext,yyout); }
L?'(\\.|[^\\'])+'															{ fputs(yytext,yyout); }
{D}+{E}{FS}?																{ fputs(yytext,yyout); }
{D}*"."{D}+({E})?{FS}?														{ fputs(yytext,yyout); }
{D}+"."{D}*({E})?{FS}?														{ fputs(yytext,yyout); }
                                                                       
L?\"(\\.|[^\\"])*\"															{ fputs(yytext,yyout); }

"..."|">>="|"<<="|"+="|"-="|"*="|"/="|"%="|"&="|"^="|"|="|">>"				{ fputs(yytext,yyout); }
"<<"|"++"|"--"|"->"|"&&"|"||"|"<="|">="|"=="|"!="|";"						{ fputs(yytext,yyout); }
("{"|"<%")|("}"|"%>")|","|":"|"="|"("|")"|("["|"<:")|("]"|":>")|"."|"&"		{ fputs(yytext,yyout); }
"!"|"~"|"-"|"+"|"*"|"/"|"%"|"<"|">"|"^"|"|"|"?"								{ fputs(yytext,yyout); }

[ \t\v\n\f]		{ ECHO; }
.				{ /* ν   ڴ  */ }

%%

/*
 * input()  input stream   ڸ ´.
 * output(c)  output stream  c  ´.
 * unput(c)  input stream  c  ־  input()    ְ Ѵ.
 */


int main(int argc, char *argv[]) {
	char *infile;					// Lex Է  Է ϸ
	char *outfile;					// Lex    ϸ
	char options[2048]="";			// CPP ɼ( ɼ)
	int options_pos;				// CPP ɼǿ ӽú.
	char unrelablefile[255];		//     ϸ
	char *temp_outfile;				// ӽ  ϸ
	uid_t uid;						//  uid  ص 
	struct stat unrelablefile_stat;	//   ü
	FILE *unrelablefile_fp;			//       
	char temp[2048];				// ӽ 
	int i,j;
	int ret;

	// ޸   {{{
	mtrace();
	// }}}

	// ⺻  Ʈ  {{{
	yyin=stdin;			// ⺻ Է Ʈ		stdin Է¹޾Ƽ ó 
	yyout=stdout;		// ⺻  Ʈ		 stdout  ° ⺻̴.
	// }}}

	//  Ͽ ȯ  о´. {{{
	load_config_file(NULL);
	// }}}
	// ڷ ־  ִٸ   Է Ѵ. {{{
	argc--;
	argv++;

	if(argc!=0) {
		infile=argv[argc-2];
		outfile=argv[argc-1];

		yyin=fopen(infile,"rt");
		if(yyin==NULL) {
			printf("* : %s    ϴ.\n",infile);
			return 1;
		}

		tmpnam(unrelablefile);
		unrelablefile_fp=fopen(unrelablefile,"wt");
		if(unrelablefile_fp==NULL) {
			printf("* : ӽ    ϴ.\n");
			return 1;
		}

		lstat(unrelablefile,&unrelablefile_stat);
		if(((unrelablefile_stat.st_mode)&S_IFREG)==0) {
			//   ƴϴ!
			return 1;
		}
		uid=getuid();
		if(unrelablefile_stat.st_uid!=uid) {
			// UID ٸ!
			return 1;
		}
		yyout=unrelablefile_fp;
		temp_outfile=unrelablefile;

	}
	// }}}

	// ⺻ ȯ ̺ о {{{
	ret=load_converting_table("/etc/hanc/basic.conv");
	if(ret==-1) {
		// б н
		fprintf(stderr,"* : ⺻ ȯ ̺(\"/etc/hanc/basic.conv\") о̴µ ߽ϴ.\n");
	}
	// }}}
	//   ȯ ̺ о {{{
	ret=load_converting_table("/etc/hanc/userdefined.conv");
	if(ret==-1) {
		// б н
		//  
	}
	// }}}

	// Lex м {{{
	yylex();
	// }}}

	// м   Ʈ  {{{
	fclose(yyin);
	fclose(yyout);
	// }}}

	//   ƴ϶ ȭ ̾ٸ ⼭ α׷  {{{
	if(yyout==stdout) {
		//   ƴ϶ ȭ ̾ٸ ⼭ α׷ 
		return 0;
	}
	// }}}

	//  CPP   ڵ  {{{
	if(yyout!=stdout) {
		options_pos=0;
		for(i=0;i<argc-2;i++) {
			for(j=0;j<strlen(argv[i]);j++) {
				if(argv[i][j]=='(' || argv[i][j]==')' || argv[i][j]=='\"'
						|| argv[i][j]=='\'') {
					options[options_pos]='\\';
					options_pos++;
				}
				options[options_pos]=argv[i][j];
				options_pos++;
			}
			options[options_pos]=' ';
			options_pos++;
		}
	}
	// }}}
	//  CPP  ,  ߻ -1  {{{
	snprintf(temp,1023,"%s %s %s %s %s",ORIG_CPP,options,"-idirafter ./",temp_outfile,outfile);
	ret=system(temp);

	if(ret==-1) {
		return 1;
	}
	// }}}

	// ׵  ӽ    {{{
	unlink(temp_outfile);
	// }}}

	//   {{{
	return 0;
	// }}}
}


/* yywrap() {{{
 * ȯ:	1 Ȥ 0
 *   :	lex   (EOF)    Լ(yywrap) ȣѴ.  yywrap() 0 ȯϸ lex   ۾ؾ   ִٴ  ϰ lex ۾ س. 1 ȯǸ lex  ۾ Ѵ.   (headerfile_yybuf_stack) ϰ   1 ȯ,   ÿ ϳ  װ lex Է ۸ 缳ϰ 0 ȯѴ.
 */
int yywrap() {
	YY_BUFFER_STATE yybuf;

	if(yybuf_stack_size()>0) {
		yy_delete_buffer(YY_CURRENT_BUFFER);
		yybuf=yybuf_stack_pop();
		yy_switch_to_buffer(yybuf);
		// puts("ּ");
		return 0;
	} else {
		return 1;
	}
}
//  }}}

/* get_english_name(ѱ̸) {{{
 * ȯ:	̸
 * :	ѱ̸ ޾ ̸  ȯѴ.
 			̸ ϱ   converting table  ãƺ,  ѱ̸ ´
			̸   ѱ θ ǥ ǰ  ̸ Ѵ.
 */
char* get_english_name(char *hangul_name) {
	int pos;
	convtbl_node convtbl_temp;

	pos=convtbl_find(hangul_name,SEARCH_BY_KOREAN);	// ѱ̸ ȯ ̺ ˻
	if(pos==-1) {	// ѱ̸ ´ ̸ ϵǾ  
		// ̸  ȯ ̺ ϰ ش ̸  {{{
		get_alphabetic_hangul(hangul_name,english_name,sizeof(english_name));
		convtbl_add(hangul_name,english_name);
		// }}}
	} else {					// ѱ̸ ´ ̸ 
		// ȯ̺ ϴ ̸  {{{
		convtbl_get(&convtbl_temp,pos);
		strncpy(english_name,convtbl_temp.english,IDENTIFIER_MAX_LENGTH);
		free(convtbl_temp.korean);
		free(convtbl_temp.english);
		// }}}
	}

	return english_name;
}
// }}}

/* load_convevrting_table(ϸ) {{{
 * ȯ:	о .( ߻ߴٸ -1)
 * :	<-> ȯ ̺  о鿩  ȯ ̺ Ų.
 			ȯ ̺     Ǿ ִ.
			-----------------------------------
			ѱ̸	̸
			-----------------------------------
			load_config_file()  Բ    Լ̹Ƿ
			  ʿϴ.
 */
int load_converting_table(char *filename) {
	char korean[IDENTIFIER_MAX_LENGTH+1];		// ѱ ̸
	char english[IDENTIFIER_MAX_LENGTH+1];		//  ̸
	FILE *fp;									// ȯǥ   
	int count=0;								// о 
	int ret;

	fp=fopen(filename,"rt");
	if(fp==NULL) {
		return -1;
	}

	while(1) {
		ret=fscanf(fp,"%200s %200s",korean,english);
		if(ret==EOF) {
			break;
		}

		convtbl_add(korean,english);

		count++;
	}

	return count;
}
// }}}

/* int include_header_file() {{{
 * ȯ:	 0, н -1
 * :	#include    ű lex Է ۸ 缳Ѵ.
 			 ۾ϴ ۴ yybuf_stack  صΰ   ۾ ϷǸ
			ٽ ű⿡ ͼ ϴ ۾ ̾ ϰ ȴ.(  yywrap()  Ѵ.)
 */
int include_header_file() {
	unsigned char c;
	char headerfile_filename[256];					//  ϸ
	int headerfile_filename_len=0;					//  ϸ ̸ 
	int user_defined_header=0;						// #incldue <stdio.h> =0, #include "helpusobi.h" =1
	char include_path[][255]={
							"/usr/include",
							"/usr/local/include"
							};						// include path, ߿ ȯ溯 ڿ  ľѴ.
	int num_include_path=2;
	char *headerfile_path;							//   θ
	FILE *headerfile_fp;							//    

	YY_BUFFER_STATE yybuf;

	int i,ret;

	// '<'  ã´. {{{
	while(1) {
		c=input();
		if(c=='<' || c=='\"') {
			user_defined_header=(c=='<') ? 0 : 1;	// '<'  ϸ 0, '"' ϸ 1
			break;
		}
	}
	// }}}
	// '>'  ö ڿ headerfile_filename  Ѵ. {{{
	while(1) {
		c=input();
		if(c=='>' || c=='\"') {
			break;
		}
		headerfile_filename[headerfile_filename_len]=c;
		headerfile_filename_len++;
	}
	headerfile_filename[headerfile_filename_len]='\0';
	// }}}
	// include table   ̸ ϴ Ȯϰ ϸ  #include  ó ʴ´. {{{
	ret=includetbl_find(headerfile_filename);
	if(ret!=-1) {
		// ̹ include ߴ ̹Ƿ ϰ ư.
		return 0;
	}
	includetbl_add(headerfile_filename);
	// }}}
	// headerfile_filename  ˻ؼ headerfile_fp  . µ ϸ -1 ȯ {{{
	if(user_defined_header==0) {
		//  ⺻ (include_path) ˻Ѵ. {{{
		for(i=0;i<num_include_path;i++) {
			headerfile_path=(char*)malloc(strlen(include_path[i])+strlen(headerfile_filename)+2);
								// ϳ NULL('\0') ,  ϳ 丮 ('/') .
			strcpy(headerfile_path,include_path[i]);
			strcat(headerfile_path,"/");
			strcat(headerfile_path,headerfile_filename);

			headerfile_fp=fopen(headerfile_path,"rt");
			if(headerfile_fp!=NULL) {
				break;
			}
			free(headerfile_path);
		}
		// }}}
	} else {
		//   ο ˻Ѵ. {{{
		headerfile_fp=fopen(headerfile_filename,"rt");
		// }}}
	}

	//  ãµ ߴٸ -1  ȯѴ. {{{
	if(headerfile_fp==NULL) {
		return -1;
	}
	// }}}
	// }}}

	//  ۾ϴ ۸ headerfile_yybuf_stack  ϰ  Ϸ lex Է ۸ 缳Ѵ. {{{
	ret=yybuf_stack_push(YY_CURRENT_BUFFER);
	if(ret==-1) {
		return -1;
	}

	yybuf=yy_create_buffer(headerfile_fp,YY_BUF_SIZE);
	yy_switch_to_buffer(yybuf);
	// }}}

	return 0;
}
// }}}

/* void bypass_comment() {{{
 * ȯ:	
 * :	ּ κ ϴ Լ̴.
			/.*    Լ ȣϰ,  Լ *./  
			  оͼ ״ Ѵ.(Lex ۾ ġ ʴ´.)
 */
void bypass_comment() {
	unsigned char c;
	char end_str[2][3]={"*/","  "};
	int i;

	fprintf(yyout,"/*");

	// "*/"  ö   ó ʰ ״ Ѵ. {{{
	while(1) {
		c=input();

		fputc(c,yyout);

		for(i=0;i<strlen(end_str[0])-1;i++) {
			end_str[1][i]=end_str[1][i+1];
		}
		end_str[1][1]=c;
		end_str[1][2]='\0';

		if(strcmp(end_str[0],end_str[1])==0) {
			break;
		}
	}
	// }}}

}
// }}}

/* load_config_file(  θ) {{{
 *	ȯ:	 0, н -1
 *	:	  о鿩 α׷ ࿡ ʿ 
 			Ѵ.
			 Լ ʱ ȹ    ʴ Լ
			Ȯ强  ϹǷ  ܺ    ؾ
			Ѵٸ ٽ ۼϴ  .
 */
int load_config_file(char *config_path) {
	char line[1024];
	char **line_buffer;
	char *line_start;
	char *varname,*varvalue;
	char default_config_path[]="/etc/hanc/hanc.conf";
	FILE *config_fp;

	line_buffer=(char**)malloc(sizeof(line)+1);

	if(config_path==NULL) {
		config_path=default_config_path;
	}

	config_fp=fopen(config_path,"rt");
	if(config_fp==NULL) {
		return -1;
	}

	while(1) {
		//   о {{{
		line_start=fgets(line,sizeof(line)-1,config_fp);
		if(line_start==NULL) {
			break;
		}
		// }}}
		//   ù ڸ Ű line_start  {{{
		while(*line_start==' ' || *line_start=='\t') {
			line_start++;
		}
		// }}}
		//   ̸ּ  ó ư {{{
		if(*line_start=='#') {
			continue;
		}
		// }}}
		//  ̸  ڷ 丷 {{{
		varname=strtok_r(line_start,"=",line_buffer);
		varvalue=strtok_r(NULL,"\n",line_buffer);
		if(varvalue==NULL) {
			//   -1 ȯ
			return -1;
		}
		// }}}
		if(strcmp(varname,"hanc_path")) {
			strcpy(config.hanc_path,varvalue);
			printf(" : %s=%s\n",varname,varvalue);
		}
		if(strcmp(varname,"gcc_path")) {
			strcpy(config.gcc_path,varvalue);
			printf(" : %s=%s\n",varname,varvalue);
		}
		if(strcmp(varname,"debug")) {
			config.debug=atoi(varvalue);
			printf(" : %s=%s\n",varname,varvalue);
		}
	}

	return 0;
}
// }}}

